import numpy as np
import os
import csv

import bpalgs

instances_path = '/Instances'



output_file_name = 'results.csv'

with open(output_file_name, 'w+', newline='') as csvfile:
    writer = csv.writer(csvfile, delimiter=',',
                            quotechar='"', quoting=csv.QUOTE_MINIMAL)
    writer.writerow(['Instances', 'Source', 'feature_n', 'feature_Mean', 'feature_Median', 'feature_Var', 'feature_Max', 'feature_Min', 'feature_Huge', 'feature_Large', 'feature_Medium', 'feature_Small', 'feature_Tiny', 'algo_FFD', 'algo_DJD'])

    # source refers to folders inside instances folder
    for source in os.listdir(os.getcwd() + instances_path):
        if os.path.isdir(os.getcwd() + instances_path + '/' + source):
            # instance_file refer to text files containing instances
            for instance_file in os.listdir(os.getcwd() + instances_path + '/' + source):

                if instance_file[-4:]=='.txt' and instance_file[:2] != '._':
                    # we have a bin packing instance to analyse
                    print(instance_file)
                    f = open(os.getcwd() + instances_path + '/' + source + '/' + instance_file)
                    fd = f.readlines()
                    n = int(fd[0]) # number of items
                    C = int(fd[1]) # capacity
                    w = list(map(int, fd[2:])) # weights
                    nw=[weight/C for weight in w] # normalised weights
                    mean = np.mean(nw)
                    median = np.median(nw)
                    var = np.var(nw)
                    maximum = max(nw)
                    minimum = min(nw)
                    huge = sum(k>0.5 for k in nw)/n
                    large = sum(0.5>=k>1/3 for k in nw)/n
                    medium = sum(1/3>=k>0.25 for k in nw)/n
                    small = sum(0.25>=k for k in nw)/n
                    tiny = sum(0.1>=k for k in nw)/n
                    FFDresult = len(bpalgs.FFDpack(w, C))-sum(nw)
                    DJDresult = len(bpalgs.DJDpack(w, C, 2, C/20))-sum(nw)
                    writer.writerow([instance_file[:-4], source, n, mean, median, var, maximum, minimum, huge, large, medium, small, tiny, FFDresult, DJDresult])
                    f.close()
